unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  RichMemo;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    RichMemo1: TRichMemo;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }


procedure ChangeParam(rm: TRichMemo; fs: TFontStyle);
var
  fp   : TFontParams;
begin
  rm.GetTextAttributes(rm.SelStart, fp);
  if fs in fp.Style then
    rm.SetRangeParams(rm.SelStart, rm.SelLength, [tmm_Styles], '', 0, clNone, [], [fs])
  else
    rm.SetRangeParams(rm.SelStart, rm.SelLength, [tmm_Styles], '', 0, clNone, [fs], []);
end;


procedure TForm1.Button1Click(Sender: TObject);
begin
  ChangeParam(RichMemo1, fsBold);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  ChangeParam(RichMemo1, fsItalic);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  ChangeParam(RichMemo1, fsUnderline);
end;

end.

